#!/usr/bin/python

##########
# Current evolution algorithm
##########
import sys, os;
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../largescale/"))
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../experiment/"))
import string, decimal, glob, re, subprocess, shlex, datetime, mydb, expdb, struct, time

#writeScheduledIDs = "none";
outDirIsAbsolute = False;
render = False;
if len(sys.argv)>=3:
	keyword = sys.argv[1];
	method = sys.argv[2];	# currently just a model name
	i=3;
	while i<len(sys.argv):
		if (sys.argv[i]=="-outDirIsAbsolute"):
			outDirIsAbsolute = True;
		elif (sys.argv[i]=="-render"):
			render = True;
#		elif (sys.argv[i]=="-writeScheduledIDs"):
#			i = i + 1;
#			writeScheduledIDs = sys.argv[i];
		else:
			print("[WARNING] Cannot understand command: "+sys.argv[i]);
		i=i+1;
else:
	print("Usage:");
	print("   python "+sys.argv[0]+" keyword method");
	print("   OPTIONS:");
#	print("       -writeScheduledIDs writeFile - write scheduled jobs");
	print("       -outDirIsAbsolute - dir is absolute");
	print("       -render - render co-aligned points");
	
	exit();

if outDirIsAbsolute:
	workDir = method+"/";
else:
	workDir = mydb.Webpage(keyword)+"/Templates/"+method+"/";
dbDir = mydb.MyDBDir(keyword);

# read labeled models and hierarchy
mList = expdb.readModelList(workDir+"LabeledModels.txt");
fHierarchy = open(workDir+"/hierarchy.bin", "rb");
nSeeds = struct.unpack('i', fHierarchy.read(4))[0];
hierarchy = struct.unpack("i"*(nSeeds), fHierarchy.read(4*nSeeds));
fHierarchy.close();

# count models in seed
counter = 0;
sys.stdout.write("Co-aligning matches ("+str(len(mList))+"): ");
# align every model to repsective domains
#jobIDs = [];
superCMD = "";
superCMDs = [];
for mInst in mList:
	if (counter % 50 == 0 and superCMD!=""):
		superCMDs.append(superCMD);
		superCMD = "";
		sys.stdout.write(str(counter)+" ");
		sys.stdout.flush();
	counter = counter + 1;
	mName = mInst.mname;
	cbegin = "./MatchTemplate "+dbDir+" -model "+mName+" -readTemplate "+workDir+"/main.tmplt ";
	cbegin += "-readBinMatch "+workDir+mName+"/match.match.bin -matchGeomName main_Even1000.pnts ";
	#cend = ";";
	cend = " > /dev/null;";
	cmd = cbegin + "-writeCoAligned "+workDir+mName+"/CoAlignedRigid.bin -1 " + cend;
	superCMD += cmd;
	#jobIDs.append(mydb.ExecuteNoWait(cmd, "Rigid_"+mName));

	# make sure that arrays include pid (current seed)
	pid = mInst.seedid;
	while pid > len(hierarchy):
		hierarchy.append(-1);

	# trace back the hierarchy - render various alignments, update model counts
	while pid >=0:
		cmd = cbegin + "-writeCoAligned "+workDir+mName+"/CoAligned_S"+str(pid)+".bin "+str(pid)+" "+cend;
		superCMD += cmd;
		#jobIDs.append(mydb.ExecuteNoWait(cmd, "CoAlign"+str(pid)+mName));
		if (pid==0):
			break;
		pid = hierarchy[pid];
sys.stdout.write(str(counter)+"\n");

if render:
	if outDirIsAbsolute:
		postfix = "-outDirIsAbsolute";
	else:
		postfix = "";
	superCMD += "./scripts/evolution/renderCoAlignPnts.py "+keyword+" "+method+" "+postfix+"; ";

if superCMD!="":
	superCMDs.append(superCMD);

# just execute as a background process - no need to wait...
#print(superCMD);
counter = 0;
sys.stdout.write("Co-aligning, executing ("+str(len(superCMDs))+"): ");
for cmd in superCMDs:
	sys.stdout.write(str(counter)+" ");
	sys.stdout.flush();
	mydb.ExecuteNoWait(cmd, "Align_"+keyword);
	counter = counter + 1;
#if (writeScheduledIDs!="none"):
#	mydb.WriteJobsFile(jobIDs, writeScheduledIDs)





