#!/usr/bin/python

##########
# Evaluate template quality (without ground truth)
##########
import sys, os;
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../largescale/"))
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../experiment/"))
import string, decimal, glob, re, subprocess, shlex, datetime, mydb, expdb, struct, time

prefixIsAbosolutePath = False;
metrics = ["SumEnergies"];
if len(sys.argv)>=4:
	keyword = sys.argv[1];
	method = sys.argv[2];
	outFile = sys.argv[3];
	i=4;
	while i<len(sys.argv):
		if (sys.argv[i]=="-metric"):
			i=i+1;
			metrics = [sys.argv[i]];
		elif (sys.argv[i]=="-metrics"):
			N = int(sys.argv[i+1]);
			metrics = sys.argv[(i+2):(i+N+2)];
			i = i + N + 1;
		elif (sys.argv[i]=="-prefixIsAbosolutePath"):
			prefixIsAbosolutePath = True;
		i = i + 1;
else: 
	print("Usage:");
	print("   python "+sys.argv[0]+" keyword method outFile [options]");
	print("   OPTIONS:");
	print("       -metric [SumEnergies SumWithoutFailure NFailures Sharpness Corrs]");
	print("       -metrics  N [metric]");
	print("       -prefixIsAbosolutePath - method is absolute path")
	print("   Output Format: metric total_score [per template score x n_templates]")
	exit();

if (prefixIsAbosolutePath):
	workDir = method;
else:
	workDir =  mydb.Webpage(keyword)+"/Templates/"+method
outStr = "";
for metric in metrics:
	print(keyword+" "+metric);
	if metric=="SumEnergies" or metric=="SumWithoutFailure" or metric=="NFailures":
		mList = mydb.ListModels(keyword);
		mLabeled = expdb.readModelList(workDir + "/LabeledModels.txt");
		energies = [];
		counters = [];
		for mInst in mLabeled:
			while len(energies) <= mInst.seedid:
				energies.append(0);
				counters.append(0);
			failed =(mInst.energy > 1000);
			maxErr = 150;
			if metric == "SumEnergies" or (metric=="SumWithoutFailure" and not failed):
				while mInst.energy > 1000:
					mInst.energy -= 1000;
				energies[0] += min(maxErr, mInst.energy);
				energies[mInst.seedid] += min(maxErr, mInst.energy);
				counters[0]+=1;
				counters[mInst.seedid] += 1;
			elif metric=="NFailures":
				if (failed):
					energies[0] += 1;
					energies[mInst.seedid] += 1;
					counters[0]=1;
					counters[mInst.seedid]=1;					
		for i in range(0, len(energies)):
			if (counters[i] > 0):
				energies[i] = int(100*(energies[i] / counters[i])) / 100.;
		outStr+=metric+" "+" ".join(str(e) for e in  energies)+"\n";
	elif metric=="Sharpness":
		cmd = "./EvalTemplate -writeFile "+workDir+"/sharpness.txt -coAlignedPointsFiles "+workDir+" "
		cmd += "-metric Sharpness -sharpnessResolution 128 128 128 -readTemplate  "+workDir+"/main.tmplt; "
		os.system(cmd);
		if not os.path.isfile(workDir+"/sharpness.txt"):
			outStr += "Sharpness_CoAligned -1\n";
			outStr += "Sharpness_RigidAligned -1\n";
		else:
			outStr += open(workDir+"/sharpness.txt", "r").read();
			os.system("rm -f "+workDir+"/sharpness.txt; ");
	elif metric=="Corrs":
		gtDir = mydb.MyDBDir(keyword)+"/../gt/";
		if os.path.isdir(gtDir):	# check if new ground truth
			cmd = "./EvalTemplate -readTemplate "+workDir+"/main.tmplt -writeFile "+workDir+"/"+outFile+" -metric Corrs ";
			cmd += "-dbDir "+mydb.MyDBDir(keyword)+" -matchDir "+workDir+" ";
			os.system(cmd);
		else:
			print("[ERROR] Cannot find ground truth directory: "+gtDir);
		cmd = "./scripts/experiment/createPlots.py corrs "+workDir+" -keyword "+keyword+" ";
		cmd += " -method "+workDir+" -prefixIsAbosolutePath ";
		os.system(cmd);
	else:
		print("[ERROR] Unknown metric: "+metric);

if metric!="Corrs":
	open(workDir+"/"+outFile, "w").write(outStr);






