#!/usr/bin/python

##########
# Label point cloud using a template
##########
import sys, os;
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../largescale/"))
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/../experiment/"))
import string, decimal, glob, re, subprocess, shlex, datetime, mydb, expdb, time

verb = True;

eval = "none";
equivLabels = "none";
useMeshThresh = "none";
matchType="match"
singleModel = "none";
inModelList = "none";
waitForJobs=False;
outDirIsAbsolute = False;
visualize = False;
readManifold = False;

readMatchesDir = "none";
readMatchesFile = "none";
alignments = "none";
writeScheduledIDs = "none";

if len(sys.argv)>=4:
	keyword = sys.argv[1];
	template = sys.argv[2];	# currently just a model name
	outDir = sys.argv[3];
	
	i=4;
	while i<len(sys.argv):
		if (sys.argv[i]=="-useMeshThresh"):
			i=i+1;
			useMeshThresh = sys.argv[i];
		elif (sys.argv[i]=="-eval"):
			i=i+1;
			eval=sys.argv[i];
		elif (sys.argv[i]=="-equivLabels"):
			i=i+1;
			equivLabels = sys.argv[i];
		elif (sys.argv[i]=="-deformOnly"):
			matchType = "deformOnly";
		elif (sys.argv[i]=="-readMatches"):
			readMatchesDir = sys.argv[i+1];
			readMatchesFile = sys.argv[i+2];
			i=i+2;
		elif (sys.argv[i]=="-waitForJobs"):
			waitForJobs = True;
		elif (sys.argv[i]=="-outDirIsAbsolute"):
			outDirIsAbsolute = True;
		elif (sys.argv[i]=="-vis"):
			visualize = True;
		elif (sys.argv[i]=="-singleModel"):
			i=i+1;
			singleModel = sys.argv[i];
		elif (sys.argv[i]=="-inModelList"):
			i=i+1;
			inModelList = sys.argv[i];
		elif (sys.argv[i]=="-readManifold"):
			readManifold = True;
		elif (sys.argv[i]=="-alignments"):
			i=i+1;
			alignments = sys.argv[i];
		elif (sys.argv[i]=="-writeScheduledIDs"):
			i=i+1;
			writeScheduledIDs = sys.argv[i];
		else:
			print("[WARNING] Cannot understand command: "+sys.argv[i]+" in labelPoints.py");
		i=i+1;
else:
	print("Usage:");
	print("   python "+sys.argv[0]+" keyword template outDir [options]");
	print("   OPTIONS:");
	print("       -outDirIsAbsolute");
	print("       -useMeshThresh value (only used if template=self)");
	print("       -eval filename");
	print("       -equivLabels filename - equivalent labels");
	print("       -waitForJobs")
	print("       -singleModel mname - modelname");
	print("       -inModelList mlist.txt - list of models");
	print("       -readMatches dirName filename - read matches");
	print("       -readManifold - shapes are manifold");
	print("       -alignments [IdentityOnly AllXYZ AllXY AllPCA] - alignments to try");
	print("       -vis");
	print("       -writeScheduledIDs jobsfile ");	
	exit();


#if verb:
#	print("   Getting models")
if singleModel!="none":
	mList = [singleModel];
elif inModelList!="none" and inModelList!="all":
	if not os.path.isfile(inModelList):
		print("[ERROR] Cannot find model file: "+inModelList+" in labePoints.py ");
		exit();
	f = open(inModelList, "r");
	mList = f.readlines();
	f.close();
	mList = [mydb.NameOnly(s.strip()) for s in mList];
else:
	mList = mydb.ListModels(keyword);
dbDir = mydb.MyDBDir(keyword);

failures=[];
failMsg=[];
errMsg=[];
mScore=[];

outMatching="";

tmpltWeb = outDir+"/";
#os.system("cp "+template+" "+tmpltWeb+"/main.tmplt")

# match every model to a template
mid=-1

matchList = [];
jobIds = [];

# render template
if (template != "self"):
	cmd = "./CreateTemplate "+dbDir+" -readTemplate "+template+" ";
	cmd += "-shotTemplate "+tmpltWeb+"template.jpg ";
	cmd += "-writeSeedHierarchy "+tmpltWeb+"hierarchy.bin "
	jobIds.append(mydb.ExecuteNoWait(cmd, "renderTmplt"));

if verb:
	sys.stdout.write("Labeling "+keyword+" ("+str(len(mList))+"): ");
counter = 0;
for mStr in mList:
	if (counter % 50 == 0):
		sys.stdout.write(str(counter)+" ");
		sys.stdout.flush();
	counter = counter + 1;

	# check if scene graph exists
	if eval!="none":
		gDir=mydb.GeometryDir(keyword, mStr);
		vFile = gDir+"/mainVals/SceneGraphNodes.vals";
		if not os.path.isfile(vFile):
			print("[WARNING] No scene graph to evaluate labels..."+vFile)

	cmd = "";
	# match model to template
	cmd += "./MatchTemplate "+dbDir+" -model "+mStr+" ";
	if (template == "self"):
		cmd += "-model "+mStr+" -train "+mStr+" main_Even"+str(expdb.NPoints())+".pnts SceneGraphNodes ";
	else:
		cmd += "-readTemplate "+template+" ";
	cmd += "-match "+mStr+" main_Even"+str(expdb.NPoints())+".pnts ";
	if (matchType=="deformOnly"):
		cmd += "-deformOnly ";

	if readMatchesDir!="none":
		matchBinFile = readMatchesDir+mStr+"/"+readMatchesFile;
		if not os.path.isfile(matchBinFile):
			print("[ERROR] Cannot find bin file: "+matchBinFile);
			exit()
		cmd += "-readBinMatch "+matchBinFile+" ";

	if not mydb.WebspaceExists() or visualize==True:
		cmd += "-vis -evalMatching print ";
	else:
		matchedDir = tmpltWeb+mStr+"/"
		if (matchType=="match"):
#			cmd += "-writeTemplateMetaData "+matchedDir+"tSelfInfo.txt ";
			cmd += "-shotMatchedSeed "+matchedDir+"matchedSeed.jpg ";
			cmd += "-shotMatchedTmpltOnly "+matchedDir+"matchedTmplt.jpg ";
			cmd += "-shotMatchedSegmentation "+matchedDir+"segPnts.jpg ";
#			cmd += "-shotMatchedSegMesh "+matchedDir+"segMesh.jpg ";
#			cmd += "-shotPartMask "+matchedDir+"segMesh.jpg ";
			cmd += "-shotTextured "+matchedDir+"textured.jpg ";
		
		cmd += "-shotMatchedDeformed "+matchedDir+matchType+".deformed.jpg ";
#		cmd += "-shotMatchedDeformedMesh "+matchedDir+matchType+".deformed.mesh.jpg ";
		cmd += "-writeMatching "+matchedDir+matchType+".matching.txt ";
		cmd += "-writeBinMatch "+matchedDir+matchType+".match.bin "
#		if (not matchType=="deformOnly"):
#			cmd += "-createFaceSegments "+matchedDir+"/"+matchType+".segface.vals ";
		matchList.append(matchedDir+matchType+".match.bin ");

		if eval!="none":
			cmd += "-evalMatching "+matchedDir+eval+"_points.txt ";
			cmd += "-evalFaces "+matchedDir+eval+"_faces.txt ";
			if (equivLabels!="none"): #equivalence classes
				cmd += "-equivLabels "+equivLabels+" ";

	if alignments!="none":
		cmd += "-alignments "+alignments+" ";

	if useMeshThresh!="none":
		cmd += "-useMeshThresh "+useMeshThresh+" ";
	if readManifold:
		cmd += "-readManifold ";

	# write command
	if (not os.path.isdir(matchedDir)):
		os.system("mkdir "+matchedDir+";");
	open(matchedDir+"/cmd_Match_"+matchType+".txt", "w").write(cmd);
	#cmd += "-vis ";
	#print(cmd);
	jobIds.append(mydb.ExecuteNoWait(cmd, mStr));
sys.stdout.write(str(counter)+"\n");

mydb.WriteJobsFile(jobIds, writeScheduledIDs);


