#!/usr/bin/python

# Python script
#  
# Prepares a collection for analysis from Co-segmentation Benchmark 
#

import os, re, glob, subprocess, shlex, sys, datetime, math, string, mydb


if len(sys.argv)>=2:
	dirname = sys.argv[1];
	outDir = sys.argv[2];
else:
	print("Usage:")
	print("   ./"+str(sys.argv[0])+" indir outdir");
	exit()


os.system("if [ ! -d " +outDir +"/ ]; then mkdir "+outDir+"; fi;");
os.system("if [ ! -d " +outDir +"/mydb ]; then mkdir "+outDir+"/mydb; fi;");

mList = glob.glob(dirname+"/*off");
if len(mList)==0:
	print("[WARNING] No models in directory "+dirname);
	exit();

for mFile in mList:
	mFile = mydb.NameOnly(mFile);
	if (len(mFile) < 4 or mFile[-4:]!=".off"):
		print("[WARNING] Cannot interpret file name "+mFile);
		continue;
	mName = mFile[:-4];

	cmd =  "./CreateGeometry "+dirname+" -dirType MeshFiles -model "+mName+".off ";
	cmd += "-outGeomName main -type MyFormat -writeDir "+outDir+"/mydb ";
	#cmd += "-rearrangeAxes x -z y; "	# other?
	os.system(cmd);



	
